VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LB_CB"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function GetComboBoxInfo Lib "user32" (ByVal hwndCombo As Long, CBInfo As COMBOBOXINFO) As Long
Private Declare Function ShowScrollBar Lib "user32" (ByVal hwnd As Long, ByVal wBar As Long, ByVal bShow As Long) As Long

Private Type COMBOBOXINFO
    cbSize       As Long
    rcItem       As RECT
    rcButton     As RECT
    stateButton  As Long
    hwndCombo    As Long
    hwndEdit     As Long
    hwndList     As Long
End Type

Private Type vLBNFO
    hwnd   As Long
    List() As String
End Type

Private Type ListRect
    XLeft   As Long
    YTop    As Long
    XRight  As Long
    YBottom As Long
End Type

Public Enum LISTINFO
    liSYSTEMFONTS = 1
    lsREGISTEREDFILETYPES = 2
    liSERVICES = 4
    liUSER = 8
End Enum

Public Enum AddInfo
    addDIRS
    addFILES
End Enum

Public Enum lbSELECTALLINFO
    lbSelectAll = 1
    lbDeSelectAll = 2
    lbSelectChange = 4
End Enum

Public Enum cbALIGMENT
    alRIGHT = 0
    alLEFT = 1
End Enum

Public Enum rsCommand
    asTEXT = 0
    asBINARY = 1
End Enum

Public Enum vlbCommand
    vlLOAD = 1
    vlSAVE = 2
    vlCLEAR = 3
End Enum

Public Enum RegReadOption
    rrEnum_KEY = 0
    rrEnum_VALUE = 1
End Enum

Public Enum SORTNFO
    soASCENDING = 0
    soDESCENDING = 1
End Enum

Public Enum BOXTYPE
    isLISTBOX = 1
    isCOMBOBOX = 2
    isUNKNOWNBOXTYP = 0
End Enum

Private Const LB_ITEMFROMPOINT = &H1A9
Private Const LB_GETITEMRECT = &H198&

Dim vLB() As vLBNFO
Public Function CB_SetDropDownState(ByVal ComboBox As Variant, _
                                    Optional isDropped As Boolean = True, _
                                    Optional ErrorNumber As Long) As Boolean
    Dim wParam As Long, hwnd As Long
    
    Const CB_SHOWDROPDOWN = &H14F

    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    hwnd = GetHwnd(ComboBox)
    
    wParam = IIf(isDropped, 1, 0)
        
    CB_SetDropDownState = (SendMessage(hwnd, CB_SHOWDROPDOWN, ByVal wParam, 0) = 1)
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(LB_CB, "CB_SetDropDownState", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function CB_GetDropDownState(ComboBox As Variant, _
                                    Optional ErrorNumber As Long) As Boolean
    Dim X As Long, hwnd As Long
    
    Const CB_GETDROPPEDSTATE = &H157

    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    hwnd = GetHwnd(ComboBox)
    
    X = SendMessage(hwnd, CB_GETDROPPEDSTATE, 0, 0)
    CB_GetDropDownState = CBool(X)
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(LB_CB, "CB_GetDropDownState", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Set_ListIndex(LBCB As Variant, ByVal Index As Long, _
                              Optional ErrorNumber As Long) As Boolean
    Dim hwnd As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    hwnd = GetHwnd(LBCB)
    
    Set_ListIndex = CBool(SendMessageLong(hwnd, LB_SETCURSEL, Index, 0))
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number

    Call ERROR(LB_CB, "Set_ListIndex", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Find(LBCB As Object, ByVal sFind As String, _
                     Optional FindExact As Boolean = False, _
                     Optional ErrorNumber As Long) As Long
        
    On Local Error GoTo Quit
    
    If TypeOf LBCB Is ListBox Then
        Find = LB_Find(LBCB, sFind, FindExact, ErrorNumber)

        Exit Function
    End If
    
    If TypeOf LBCB Is ComboBox Then
        Find = CB_Find(LBCB, sFind, FindExact, ErrorNumber)
        
        Exit Function
    End If
    
    Find = -3
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(LB_CB, "Find", Err.Number, Err.Description)
   
    Err.Clear
    
End Function
Public Function LB_Find(ListBox As Object, ByVal Find As String, _
                       Optional FindExact As Boolean = False, _
                       Optional ErrorNumber As Long) As Long
    Dim P As Long
       
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    LB_Find = SearchLB(ListBox.hwnd, LB_FINDSTRINGEXACT, -1, Find)
        
    If Not FindExact Then Exit Function
    
    If LB_Find > -1 Then
        For P = LB_Find To ListBox.ListCount - 1
            If ListBox.List(P) = Find Then
                LB_Find = P
                                                          
                Exit Function
            End If
        Next P
    
        LB_Find = -1
    End If
    
    Exit Function

Quit:
    ErrorNumber = Err.Number
    LB_Find = -2
    
    Call ERROR(LB_CB, "LB_Find", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function CB_Find(ComboBox As Object, ByVal Find As String, _
                        Optional FindExact As Boolean = False, _
                        Optional ErrorNumber As Long) As Long
    Dim P As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    CB_Find = SearchLB(ComboBox.hwnd, CB_FINDSTRINGEXACT, -1, Find)
        
    If Not FindExact Then Exit Function
    
    If CB_Find > -1 Then
        For P = CB_Find To ComboBox.ListCount - 1
            If Find = ComboBox.List(P) Then
                CB_Find = P
                
                Exit Function
            End If
        Next P
    
        CB_Find = -1
    End If
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    CB_Find = -2
    
    Call ERROR(LB_CB, "CB_Find", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Sort(LBCB As Object, sSort As SORTNFO) As Long
    Dim frm As New MyControls
    
    On Local Error GoTo Quit
    
    If LBCB.Sorted Then Exit Function
    
    Select Case sSort
        Case soDESCENDING
            Load frm
            frm.Tag = "Sort"
    
            Call frm.SortLB(LBCB)
            
            Unload frm
            Set frm = Nothing
        Case soASCENDING
            Call LBSortItem(LBCB)
    End Select
    
    Exit Function
    
Quit:
    Sort = Err.Number

    Call ERROR(LB_CB, "Sort", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Get_MaxValue(LBCB As Object, MaxStr As String, _
                             Optional ErrorNumber As Long) As Long
    Dim P As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If LBCB.ListCount > 0 Then
        Get_MaxValue = 0
        MaxStr = LBCB.List(0)
        
        For P = 0 To LBCB.ListCount - 1
            If LBCB.List(P) > MaxStr Then
                MaxStr = LBCB.List(P)
                Get_MaxValue = P
            End If
        Next P
    Else
        MaxStr = ""
        Get_MaxValue = -1
    End If
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    MaxStr = ""
    Get_MaxValue = -2
    
    Call ERROR(LB_CB, "Get_MaxValue", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Get_MinValue(LBCB As Object, MinStr As String, _
                             ErrorNumber As Long) As Long
    Dim P As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
        
    If LBCB.ListCount > 0 Then
        MinStr = LBCB.List(0)
        Get_MinValue = 0
    
        For P = 0 To LBCB.ListCount - 1
            If LBCB.List(P) < MinStr Then
                Get_MinValue = P
                MinStr = LBCB.List(P)
            End If
        Next P
    Else
        MinStr = ""
        Get_MinValue = -1
    End If
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    MinStr = ""
    Get_MinValue = -2
    
    Call ERROR(LB_CB, "Get_MinValue", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function RemoveItem(LBCB As Object, ByVal Value As String, _
                           Optional FindExact As Boolean) As Long
    Dim P As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    If Not FindExact Then Value = LCase$(Value)

    For P = (LBCB.ListCount - 1) To 0 Step -1
        R$ = IIf(FindExact, LBCB.List(P), LCase$(LBCB.List(P)))
        
        If R$ = Value Then LBCB.RemoveItem P
    Next P
    
    Exit Function
    
Quit:
    RemoveItem = Err.Number
    
    Call ERROR(LB_CB, "RemoveItem", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function Kill_DoubleItem(LBCB As Object, ByVal Value As String, _
                                Optional FindExact As Boolean) As Long
    Dim P As Long, Index As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    If Not FindExact Then Value = LCase$(Value)
    
    Index = Find(LBCB, Value, FindExact)
    
    If Index = -2 Then
        Kill_DoubleItem = -2
        
        Exit Function
    End If
    
    If LBCB.ListCount > (Index + 1) Then
        For P = (LBCB.ListCount - 1) To (Index + 1) Step -1
            R$ = IIf(FindExact, LBCB.List(P), LCase$(LBCB.List(P)))
            
            If R$ = Value Then LBCB.RemoveItem P
        Next P
    End If
    
    Exit Function
    
Quit:
    Kill_DoubleItem = Err.Number
    
    Call ERROR(LB_CB, "Kill_DoubleItem", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Kill_DoubleItems(LBCB As Object, _
                                 Optional FindExact As Boolean) As Long
    Dim P As Long
    Dim LBitem() As String, Find As String
    Dim LBID() As Long, cmd As Long

    On Local Error GoTo Quit
    
    cmd = Cis(LBCB, cisFINDSTRINGEXACT)
    
    If cmd = -2 Then
        Kill_DoubleItems = -2
        
        Exit Function
    End If
                     
    If LBCB.ListCount = 0 Then Exit Function
    
    ReDim LBitem(0)
    ReDim LBID(0)
        
    Do While LBCB.ListCount
        ReDim Preserve LBitem(UBound(LBitem) + 1)
        ReDim Preserve LBID(UBound(LBID) + 1)
        
        LBitem(UBound(LBitem)) = LBCB.List(0)
        LBID(UBound(LBID)) = LBCB.ItemData(0)
        
        Find = LBitem(UBound(LBitem))
        
        LBCB.RemoveItem 0
                
        P = SearchLB(LBCB.hwnd, cmd, -1, Find)

        If (Not FindExact) Or (FindExact And LBCB.List(P) = Find) Then
            Do While P > -1
                LBCB.RemoveItem P
                P = SearchLB(LBCB.hwnd, cmd, -1, Find)
            Loop
        End If
    Loop
    
    LBCB.Clear
    
    For P = 1 To UBound(LBitem)
        LBCB.AddItem LBitem(P)
        LBCB.ItemData(LBCB.NewIndex) = LBID(P)
    Next P
      
    Exit Function
    
Quit:
    Kill_DoubleItems = Err.Number

    Call ERROR(LB_CB, "Kill_DoubleItems", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function CB_SetAlignment(ComboBox As Object, Alignment As cbALIGMENT) As Long
    Dim hList As Long, nStyle As Long
    Dim CBI As COMBOBOXINFO

    On Local Error GoTo Quit

    CBI.cbSize = Len(CBI)
    Call GetComboBoxInfo(ComboBox.hwnd, CBI)
    hList = CBI.hwndList

    If hList Then
        nStyle = GetWindowLong(hList, GWL_EXSTYLE)
      
        Select Case Alignment
            Case alLEFT:  nStyle = nStyle And Not WS_EX_RIGHT
            Case alRIGHT: nStyle = nStyle Or WS_EX_RIGHT
        End Select
      
        Call SetWindowLong(hList, GWL_EXSTYLE, nStyle)
    End If
   
    Exit Function
   
Quit:
    CB_SetAlignment = Err.Number

    Call ERROR(LB_CB, "CB_SetAlignment", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function LB_MouseMove(ListBox As Object, _
                             ByVal X As Single, ByVal Y As Single, _
                             Optional SetMousePointer As Boolean = True, _
                             Optional SetToolTip As Boolean = True, _
                             Optional ErrorNumber As Long) As Long
    Dim Index As Long, MP As Long
    Dim TT$
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Index = LB_GetIndexUnderMouse(ListBox, X, Y)
    
    If Index >= ListBox.ListCount Then
        Index = -1
        MP = 12
        TT$ = ""
    Else
        MP = 0
        TT$ = ListBox.List(Index)
    End If
    
    ListBox.ListIndex = Index
    LB_MouseMove = Index
    
    If SetMousePointer Then ListBox.MousePointer = MP
    If SetToolTip Then ListBox.ToolTipText = TT$
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    LB_MouseMove = -2

    Call ERROR(LB_CB, "LB_MouseMove", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function AddArray(LBCB As Object, sArray As Variant, _
                         Optional AllowDouble As Boolean = True, _
                         Optional ClearBeforeAdding As Boolean = True) As Long
    Dim P As Long
    
    On Local Error GoTo Quit
    
    If ClearBeforeAdding Then LBCB.Clear
    
    If DLL.ARRAY.isDIM(sArray) Then
         For P = LBound(sArray) To UBound(sArray)
            If AllowDouble Then
                LBCB.AddItem sArray(P)
            Else
                Call Add(LBCB, sArray(P), , , AllowDouble)
            End If
        Next P
    End If

    Exit Function

Quit:
    If Err.Number = 9 Then Err.Clear
    
    If Err.Number <> 0 Then
        AddArray = Err.Number

        Call ERROR(LB_CB, "AddArray", Err.Number, Err.Description)
        
        Err.Clear
    End If

End Function
Public Function ToArray(LBCB As Object, sArray As Variant, _
                        Optional WriteSorted As Boolean = False) As Long
    Dim Lc As Long, P As Long
        
    On Local Error GoTo Quit
    
    Lc = (LBCB.ListCount - 1)
    
    If Lc = -1 Then
        Erase sArray
        
        Exit Function
    End If
    
    ReDim sArray(Lc)
    
    For P = 0 To Lc
        sArray(P) = LBCB.List(P)
    Next P
    
    If WriteSorted Then ToArray = DLL.ARRAY.Sort(sArray)
    
    Exit Function
    
Quit:
    ToArray = Err.Number
    
    Call ERROR(LB_CB, "ToArray", Err.Number, Err.Description)
            
    Err.Clear
    
End Function
Public Function Replace(LBCB As Object, ByVal SearchFor As String, _
                        ByVal ReplaceWith As String, _
                        Optional FindExact As Boolean = True) As Long
    Dim P As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    If SearchFor = ReplaceWith Then Exit Function
    
    SearchFor = IIf(FindExact, SearchFor, LCase$(SearchFor))
    
    For P = 0 To LBCB.ListCount - 1
        R$ = IIf(FindExact, LBCB.List(P), LCase$(LBCB.List(P)))
        
        If R$ = SearchFor Then LBCB.List(P) = ReplaceWith
    Next P
    
    Exit Function
    
Quit:
    Replace = Err.Number

    Call ERROR(LB_CB, "Replace", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function vListBox(LBCB As Object, _
                         ByVal Command As vlbCommand, _
                         Optional Index As Long = 0, _
                         Optional ErrorNumber As Long) As Long
    Dim P As Long
    Dim Found As Boolean
    
    On Local Error Resume Next
    
    ErrorNumber = 0
    
    P = UBound(vLB)
    
    If Err.Number <> 0 Then
        ReDim vLB(0)
        Err.Clear
    End If
    
    On Local Error GoTo Quit
    
    If Index = 0 Or (Command = vlSAVE) Then
        For P = 1 To UBound(vLB)
            If vLB(P).hwnd = LBCB.hwnd Then
                Found = True
                
                Exit For
            End If
        Next P
    
        If Not Found Then
            ReDim Preserve vLB(UBound(vLB) + 1)
            P = UBound(vLB)
        End If
                
        vListBox = P
    Else
        If Index < 1 Or Index > UBound(vLB) Then Exit Function
        
        vListBox = Index
    End If
    
    Select Case Command
        Case vlSAVE
            vLB(vListBox).hwnd = LBCB.hwnd
            
            ReDim vLB(vListBox).List(LBCB.ListCount - 1, 2)
            
            For P = 0 To LBCB.ListCount - 1
                vLB(vListBox).List(P, 1) = LBCB.List(P)
                vLB(vListBox).List(P, 2) = LBCB.ItemData(P)
            Next P
        Case vlLOAD
            LBCB.Clear
            P = 0
            
            On Local Error Resume Next
            
            Do
                LBCB.AddItem vLB(vListBox).List(P, 1)
                LBCB.ItemData(LBCB.NewIndex) = CLng(vLB(vListBox).List(P, 2))
                
                If Err.Number <> 0 Then Exit Do
                
                P = P + 1
            Loop
        Case vlCLEAR
            Erase vLB
    End Select
    
    Exit Function

Quit:
    ErrorNumber = Err.Number
    vListBox = -2

    Call ERROR(LB_CB, "vListBox", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function CB_MaxLength(ComboBox As Object, ByVal MaxLenght As Long) As Long
    Dim hWndCmb As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    With ComboBox
        hWndCmb = FindWindowEx(.hwnd, 0&, vbNullString, vbNullString)
  
        R$ = .TEXT
        .TEXT = ""
        
        Call SendMessage(hWndCmb, EM_LIMITTEXT, MaxLenght, 0&)
    
        If Len(R$) Then
            If Len(R$) < (MaxLenght + 1) Then
                .TEXT = R$
            Else
                R$ = mID(R$, 1, MaxLenght)
            End If
                
            .TEXT = R$
            .SelStart = Len(R$)
        End If
    End With
    
    Exit Function
    
Quit:
    CB_MaxLength = Err.Number

    Call ERROR(LB_CB, "CB_MaxLength", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function CB_SetText(ByVal ComboBox As Variant, ByVal TEXT As String, _
                           Optional ErrorNumber As Long) As Boolean
    Dim hEdit As Long, hwnd As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    hwnd = GetHwnd(ComboBox)
    
    hEdit = FindWindowEx(hwnd, 0&, "Edit", vbNullString)
    If hEdit Then CB_SetText = DLL.WINDOW.Set_Text(hEdit, TEXT)

    Exit Function
    
Quit:
    ErrorNumber = Err.Number

    Call ERROR(LB_CB, "CB_SetText", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function ToString(LBCB As Object, Optional ErrorNumber As Long) As String
    Dim P As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    For P = 0 To LBCB.ListCount - 1
        R$ = R$ & LBCB.List(P) & Chr$(0)
    Next P
    
    If Len(R$) Then R$ = Left$(R$, Len(R$) - 1)
    
    ToString = R$
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    ToString = ""
    
    Call ERROR(LB_CB, "ToString", Err.Number, Err.Description)
 
    Err.Clear
    
End Function
Public Function SaveToFile(LBCB As Object, ByVal File As String) As Long
    Dim R$
    Dim P As Long
    
    On Local Error GoTo Quit
    
    For P = 0 To LBCB.ListCount - 1
        R$ = R$ & LBCB.List(P) & vbCrLf
    Next P
    
    If Len(R$) Then R$ = Left$(R$, Len(R$) - 2)
    
    SaveToFile = DLL.TEXT.TextFile_WriteText(File, R$)
        
    Exit Function
        
Quit:
    SaveToFile = Err.Number

    Call ERROR(LB_CB, "SaveToFile", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function LoadFromFile(LBCB As Object, ByVal File As String, _
                             ReadAs As rsCommand) As Long
    Dim A() As String, R$
    
    On Local Error GoTo Quit
    
    Select Case ReadAs
        Case asTEXT
            R$ = DLL.TEXT.TextFile_Read(File, LoadFromFile)
            
            If LoadFromFile <> 0 Then Exit Function

            A = Split(R$, vbCrLf)
        Case asBINARY
            A = DLL.ARRAY.Array_ReadFromFile(File, LoadFromFile)
            
            If LoadFromFile <> 0 Then Exit Function
    End Select
    
    LoadFromFile = AddArray(LBCB, A, True, True)

    Exit Function

Quit:
    LoadFromFile = Err.Number

    Call ERROR(LB_CB, "LoadFromFile", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function CountItem(LBCB As Object, ByVal Item As String, _
                          Optional FindExact As Boolean = False, _
                          Optional ErrorNumber As Long) As Long
    Dim P As Long, X As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If Not FindExact Then Item = LCase$(Item)
    
    For P = 0 To LBCB.ListCount - 1
        R$ = IIf(FindExact, LBCB.List(P), LCase$(LBCB.List(P)))
                
        If R$ = Item Then X = X + 1
    Next P
    
    CountItem = X
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    CountItem = -2
    
    Call ERROR(LB_CB, "CountItem", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function ItemExist(LBCB As Object, ByVal Value As String, _
                          Optional FindExact As Boolean = False, _
                          Optional ErrorNumber As Long) As Boolean
    Dim Index As Long
    
    Index = Find(LBCB, Value, FindExact, ErrorNumber)
    
    If ErrorNumber <> 0 Then Exit Function
    
    If Index > -1 Then ItemExist = True
    
End Function
Public Function FindPhrase(LBCB As Object, ByVal Find As String, _
                           Optional FindAtPosition As Long = -1, _
                           Optional FindExact As Boolean = True, _
                           Optional ErrorNumber As Long) As Long
    Dim P As Long, Index As Long
    Dim R$
        
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If Not FindExact Then Find = LCase$(Find)
    
    For P = 0 To LBCB.ListCount - 1
        R$ = IIf(FindExact, LBCB.List(P), LCase$(LBCB.List(P)))
        Index = InStr(R$, Find)

        If FindAtPosition < 0 Then
            If Index > 0 Then
                FindPhrase = P
                Exit Function
            End If
        Else
            If Index = FindAtPosition Then
                FindPhrase = P
                Exit Function
            End If
        End If
    Next P
    
Quit:
    If Err.Number <> 0 Then
        ErrorNumber = Err.Number
        FindPhrase = -2
        
        Call ERROR(LB_CB, "FindPhrase", Err.Number, Err.Description)
    End If
    
    CB_AutoCompleteWORK = False
    
End Function
Public Function CB_AutoComplete(ComboBox As Object, _
                                Optional ErrorNumber As Long) As Long
    Dim X As Long, Key As Long, P As Long
    Dim S$, R$
    
    On Local Error GoTo Quit
    
    If CB_AutoCompleteWORK Then
        CB_AutoComplete = -3
        Exit Function
    End If

    ErrorNumber = 0
    
    Key = DLL.HARDWARE.Keyboard_GetPressedKey
    
    If Key = 8 Or Key = 46 Then
        CB_AutoComplete = -4
        Exit Function
    End If

    If ComboBox.TEXT = "" Then
        CB_AutoComplete = -1
        Exit Function
    End If

    CB_AutoCompleteWORK = True
    
    X = -1
    
    For P = 0 To (ComboBox.ListCount - 1)
        R$ = LCase$(ComboBox.List(P))
    
        If InStr(R$, LCase$(ComboBox.TEXT)) = 1 Then
            X = P
            Exit For
        End If
    Next P
    
    If X > -1 Then
        S$ = LCase$(ComboBox.List(X))
        R$ = LCase$(ComboBox.TEXT)
        
        If S$ <> R$ Then
            ComboBox.TEXT = S$
            ComboBox.SelStart = Len(R$)
            ComboBox.SelLength = Len(S$)
        End If
    End If
    
    CB_AutoComplete = X
    
Quit:
    If Err.Number <> 0 Then
        ErrorNumber = Err.Number
        CB_AutoComplete = -2
        
        Call ERROR(LB_CB, "CB_AutoComplete", Err.Number, Err.Description)
    End If
    
    CB_AutoCompleteWORK = False

    Err.Clear
    
End Function
Public Function CB_SetDropDownHeight(ComboBox As Object, _
                                     ByVal newHeight As Long) As Long
    Dim Ys As Long

    On Local Error GoTo Quit
    
    Ys = Screen.Height / Screen.TwipsPerPixelY
    If newHeight > Ys / 2 Then newHeight = newHeight / 2
 
    With ComboBox
        Call MoveWindow(.hwnd, .Left / Screen.TwipsPerPixelX, .Top / Screen.TwipsPerPixelY, _
                               .Width / Screen.TwipsPerPixelY, newHeight, 1)
    End With
    
    Exit Function
    
Quit:
    CB_SetDropDownHeight = Err.Number

    Call ERROR(LB_CB, "CB_SetDropDownHeight", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function CB_SetDropDownWidth(ComboBox As Object, ByVal NewWidth As Long, _
                                    Optional ErrorNumber As Long) As Boolean
    
    Const CB_SETDROPPEDWIDTH = &H160

    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    CB_SetDropDownWidth = (SendMessage(ComboBox.hwnd, CB_SETDROPPEDWIDTH, _
                                       NewWidth, 0&) <> 0)

    Exit Function
    
Quit:
    ErrorNumber = Err.Number

    Call ERROR(LB_CB, "CB_SetDropDownWidth", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function LB_ScrollBarIsVisible(ListBox As Object, _
                                      ByVal ScrollBarIsVisible As Boolean) As Long
        
    Const SB_VERT = 1
    
    On Local Error GoTo Quit

    Call ShowScrollBar(ListBox.hwnd, SB_VERT, CLng(ScrollBarIsVisible))
                       
    Exit Function
    
Quit:
    LB_ScrollBarIsVisible = Err.Number

    Call ERROR(LB_CB, "LB_ScrollBarIsVisible", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function LB_HorizontalScrollbar(ListBox As Object) As Long
    Dim L As Long
    
    Const LB_SETHORIZONTALEXTENT = &H194

    On Local Error GoTo Quit
    
    L = LB_GetMaxItemLen(ListBox, LB_HorizontalScrollbar)
    
    If LB_HorizontalScrollbar <> 0 Then Exit Function
    
    If L > -1 Then Call SendMessage(ListBox.hwnd, LB_SETHORIZONTALEXTENT, L, 0&)
    
    Exit Function
    
Quit:
    LB_HorizontalScrollbar = Err.Number

    Call ERROR(LB_CB, "LB_HorizontalScrollbar", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function LB_GetMaxItemLen(ListBox As Object, _
                                 Optional ErrorNumber As Long) As Long
    Dim oldFont As StdFont
    Dim Lg As Long, M As Long, SM As Long, oldMode As Long
    
    Const SM_CXVScroll = 2
    
    On Local Error GoTo Quit
   
    ErrorNumber = 0
   
    SM = GetSystemMetrics(SM_CXVScroll)
    
    oldMode = ListBox.Parent.ScaleMode
    ListBox.Parent.ScaleMode = 1
   
    Set oldFont = ListBox.Parent.Font
    Set ListBox.Parent.Font = ListBox.Font

    For M = 0 To ListBox.ListCount - 1
        If ListBox.Parent.TextWidth(ListBox.List(M)) > Lg Then Lg = ListBox.Parent.TextWidth(ListBox.List(M))
    Next M
   
    Lg = Lg / Screen.TwipsPerPixelX
    Lg = Lg + SM
   
    LB_GetMaxItemLen = Lg

    ListBox.Parent.ScaleMode = oldMode
    Set ListBox.Parent.Font = oldFont

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    LB_GetMaxItemLen = -2
    
    Call ERROR(LB_CB, "LB_GetMaxItemLen", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function LB_GetSelectedItems(ListBox As Object, _
                                    Optional ErrorNumber As Long) As Long()
    Dim A() As Long, P As Long, X As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    X = 0
    
    For P = 0 To ListBox.ListCount - 1
        If ListBox.Selected(P) Then
            ReDim Preserve A(X)
            
            A(X) = P
            X = X + 1
        End If
    Next P
    
    LB_GetSelectedItems = A
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Erase LB_GetSelectedItems
    
    Call ERROR(LB_CB, "LB_GetSelectedItems", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function LB_GetSelectedItemsText(ListBox As Object, _
                                        Optional ErrorNumber As Long) As String()
    Dim A() As Long, P As Long
    Dim R() As String
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    A = LB_GetSelectedItems(ListBox, ErrorNumber)
    
    If ErrorNumber <> 0 Then Exit Function
    
    If DLL.ARRAY.isDIM(A) Then
        ReDim R(UBound(A))
        
        For P = 0 To UBound(A)
            R(P) = ListBox.List(A(P))
        Next P
    Else
        Erase R
    End If
    
    LB_GetSelectedItemsText = R
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Erase LB_GetSelectedItemsText
    
    Call ERROR(LB_CB, "LB_GetSelectedItemsText", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function LB_RemoveSelectedItems(ListBox As Object) As Long
    Dim P As Long
    
    On Local Error GoTo Quit
    
    For P = (ListBox.ListCount - 1) To 0 Step -1
        If ListBox.Selected(P) Then ListBox.RemoveItem P
    Next P
    
    Exit Function
    
Quit:
    LB_RemoveSelectedItems = Err.Number

    Call ERROR(LB_CB, "LB_RemoveSelectedItems", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function LB_GetItemUnderMouse(ListBox As Object, _
                                     ByVal X As Single, ByVal Y As Single, _
                                     Optional ErrorNumber As Long) As String
    Dim Index As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Index = LB_GetIndexUnderMouse(ListBox, X, Y, ErrorNumber)
    
    If ErrorNumber <> 0 Then Exit Function
    
    LB_GetItemUnderMouse = ListBox.List(Index)

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    LB_GetItemUnderMouse = ""
    
    Call ERROR(LB_CB, "LB_GetItemUnderMouse", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function LB_GetIndexUnderMouse(ListBox As Object, _
                                      ByVal X As Single, ByVal Y As Single, _
                                      Optional ErrorNumber As Long) As Long
    Dim Index As Long, lX As Long, lY As Long, Param As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    lX = ListBox.Parent.ScaleX(X, vbTwips, vbPixels)
    lY = ListBox.Parent.ScaleY(Y, vbTwips, vbPixels)
    
    Param = CLng(lX) + &H10000 * CLng(lY)

    Index = SendMessage(ListBox.hwnd, LB_ITEMFROMPOINT, 0, ByVal Param)

    If Index > ListBox.ListCount Then Index = -1
    
    LB_GetIndexUnderMouse = Index
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    LB_GetIndexUnderMouse = -2
    
    Call ERROR(LB_CB, "LB_GetIndexUnderMouse", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function LB_ListEdit(ListBox As Object, _
                            Optional AddInputToLB As Boolean = False, _
                            Optional MaxInputLength As Long = 0, _
                            Optional AllowEmpty As Boolean = True, _
                            Optional CancelOnESC As Boolean = False, _
                            Optional ErrorNumber As Long) As String
    Dim I As Long, nIndex As Long, hwnd As Long
    Dim nTopIndex As Long, nItemHeight As Long
    Dim frm As Form
    
    Const LB_GETTOPINDEX = &H18E

Start:
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    hwnd = ListBox.Parent.hwnd

    nTopIndex = SendMessage(ListBox.hwnd, LB_GETTOPINDEX, 0, 0)
    nItemHeight = SendMessage(ListBox.hwnd, LB_GETITEMHEIGHT, 0, 0) * Screen.TwipsPerPixelY

    nIndex = ListBox.ListIndex

    If ((nIndex > ListBox.ListCount) Or nIndex < 0) Or ListEditWork Then
        LB_ListEdit = Chr$(0)
        Exit Function
    End If
        
    If Not ListEditWork Then
        For I = 0 To FORMS.Count - 1
            If FORMS(I).Tag = "LB_ListEdit" & CStr(ListBox.hwnd) Then
                FORMS(I).uInput.Tag = "new"
                               
                LB_ListEdit = Chr$(0)
                
                Exit Function
            End If
        Next I
    
        Set frm = New MyControls
        Load frm
                
        frm.ListEdit = True
        frm.ListEditESC = CancelOnESC
        frm.ListEditEmpty = AllowEmpty
    End If
    
    Call Set_ListIndex(ListBox, -1)

    With frm
        .Tag = "LB_ListEdit" & CStr(ListBox.hwnd)
        .ScaleMode = ListBox.Parent.ScaleMode

        With .uInput
            If Not ListEditWork Then
                ListEditWork = True
                
                If MaxInputLength > 0 Then .MaxLength = MaxInputLength
                
                .Font = ListBox.Font
                .FontSize = ListBox.FontSize
                .Width = ListBox.Width
            
                Call DLL.WINDOW.Set_Parent(.hwnd, ListBox.hwnd)
            
                .Left = 0
                .Height = nItemHeight
            End If
            
            .Top = (nIndex - nTopIndex) * nItemHeight
            .TEXT = ListBox.List(nIndex)
            .Visible = True

            olduString = .TEXT
            .SelStart = Len(.TEXT)
            
            .ZOrder
            .Refresh
            
            Call DLL.WINDOW.Set_Focus(.hwnd)
        End With
        
        Do
            If DLL.WINDOW.Get_TaskID(hwnd) = 0 Then
                Exit Do
            Else
                If .uInput.Tag = "new" Then
                    .uInput.Tag = ""
                    GoTo Start
                End If
            
                If .uStringWasSet Then
                    If AddInputToLB Then ListBox.List(nIndex) = .uString
        
                    LB_ListEdit = .uString
        
                    Exit Do
                End If
            End If
            
            DoEvents
        Loop
    End With
    
Quit:
    If Err.Number <> 0 Then
        ErrorNumber = Err.Number
        LB_ListEdit = ""

        Call ERROR(LB_CB, "LB_ListEdit", Err.Number, Err.Description)
    Else
        Unload frm
    End If
    
    Set frm = Nothing

    ListEditWork = False
    
    Err.Clear

End Function
Public Function ItemData_Find(LBCB As Object, ByVal ItemData As Long, _
                              Optional ErrorNumber As Long) As Long
    Dim P As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    For P = 0 To LBCB.ListCount - 1
        If LBCB.ItemData(P) = ItemData Then
            ItemData_Find = P
            
            Exit Function
        End If
    Next P
    
    ItemData_Find = -1
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    ItemData_Find = -2
    
    Call ERROR(LB_CB, "ItemData_Find", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function ItemData_Exist(LBCB As Object, ByVal ItemData As Long, _
                               Optional ErrorNumber As Long) As Boolean
    Dim Index As Long
    
    ErrorNumber = 0
    
    Index = ItemData_Find(LBCB, ItemData, ErrorNumber)
    
    If ErrorNumber <> 0 Then Exit Function
    
    ItemData_Exist = (Index > -1)
    
End Function
Public Function ItemData_GetMaxValue(LBCB As Object, _
                                     Optional ErrorNumber As Long) As Long
    Dim P As Long
    
    On Local Error GoTo Quit

    ErrorNumber = 0
    
    If LBCB.ListCount > -1 Then ItemData_GetMaxValue = LBCB.ItemData(0)

    For P = 1 To LBCB.ListCount - 1
        If LBCB.ItemData(P) > ItemData_GetMaxValue Then ItemData_GetMaxValue = LBCB.ItemData(P)
    Next P

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    ItemData_GetMaxValue = -2
    
    Call ERROR(LB_CB, "ItemData_GetMaxValue", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function ItemData_GetMinValue(LBCB As Object, _
                                     Optional ErrorNumber As Long) As Long
    Dim P As Long
    
    On Local Error GoTo Quit

    ErrorNumber = 0
    
    If LBCB.ListCount > 0 Then ItemData_GetMinValue = LBCB.ItemData(0)

    For P = 1 To LBCB.ListCount - 1
        If LBCB.ItemData(P) < ItemData_GetMinValue Then ItemData_GetMinValue = LBCB.ItemData(P)
    Next P

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    ItemData_GetMinValue = -2
    
    Call ERROR(LB_CB, "ItemData_GetMinValue", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function ItemData_Count(LBCB As Object, ByVal ItemData As Long, _
                               Optional ErrorNumber As Long) As Long
    Dim P As Long, X As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    X = 0
    
    For P = 0 To LBCB.ListCount - 1
        If LBCB.ItemData(P) = ItemData Then X = X + 1
    Next P
    
    ItemData_Count = X
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    ItemData_Count = -2
    
    Call ERROR(LB_CB, "ItemData_Count", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function ItemData_ToArray(LBCB As Object, _
                                  Optional ErrorNumber As Long) As Variant
    Dim L() As Long, P As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If LBCB.ListCount = 0 Then Exit Function
    
    ReDim L(LBCB.ListCount - 1)
    
    For P = 0 To (LBCB.ListCount - 1)
        L(P) = LBCB.ItemData(P)
    Next P
    
    ItemData_ToArray = L
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(LB_CB, "ItemData_ToArray", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function ItemData_Fill(LBCB As Object, ByVal ItemData As Long, _
                              Optional StartIndex As Long = -1, _
                              Optional EndIndex As Long = -1) As Long
    Dim P As Long, S As Long, E As Long
    
    On Local Error GoTo Quit
    
    S = StartIndex
    If StartIndex = -1 Then S = 0
    
    E = EndIndex
    If EndIndex = -1 Then E = (LBCB.ListCount - 1)
    
    For P = S To E
        LBCB.ItemData(P) = ItemData
    Next P
    
    Exit Function
    
Quit:
    ItemData_Fill = Err.Number

    Call ERROR(LB_CB, "ItemData_Fill", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function apiAdd(ByVal hwnd As Long, ByVal StringToAdd As String, _
                        Optional Index As Long = -1, _
                        Optional AllowDouble As Boolean = True, _
                        Optional ErrorNumber As Long) As Long
    Dim BOXTYP As BOXTYPE
    Dim ItemText As String
    Dim P As Long, wMsg As Long, wMsg2 As Long, Count As Long, TextLen As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    BOXTYP = Get_BoxTypeByHwnd(hwnd)
    
    If Not AllowDouble Then
        Select Case BOXTYP
            Case isCOMBOBOX:      wMsg = CB_GETLBTEXTLEN
                                  wMsg2 = CB_GETLBTEXT
            Case isLISTBOX:       wMsg = LB_GETTEXTLEN
                                  wMsg2 = LB_GETTEXT
            Case isUNKNOWNBOXTYP: apiAdd = -2
                                  Exit Function
        End Select
    
        Count = apiItemCount(hwnd)

        If Count Then
            For P = 0 To (Count - 1)
                TextLen = SendMessage(hwnd, wMsg, ByVal CLng(P), ByVal CLng(0))
                ItemText = Space(TextLen) & vbNullChar
                TextLen = SendMessage(hwnd, wMsg2, ByVal CLng(P), ByVal ItemText)
                ItemText = Left(ItemText, TextLen)
            
                If ItemText = StringToAdd Then Exit Function
            Next P
        End If
    End If
    
    Select Case BOXTYP
        Case isCOMBOBOX:      wMsg = CB_INSERTSTRING
        Case isLISTBOX:       wMsg = LB_INSERTSTRING
        Case isUNKNOWNBOXTYP: apiAdd = -2
                              Exit Function
    End Select
    
    apiAdd = SendMessage(hwnd, wMsg, ByVal CLng(Index), ByVal StringToAdd)
    
    Exit Function
    
Quit:
    apiAdd = Err.Number
    
    Call ERROR(LB_CB, "apiAdd", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Add(ByVal LBCB As Object, ByVal StringToAdd As String, _
                    Optional ItemData As Long = 0, Optional Index As Long = -1, _
                    Optional AllowDouble As Boolean = True, _
                    Optional ErrorNumber As Long) As Long
    Dim NW As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If Not AllowDouble Then
        If Find(LBCB, StringToAdd, True) > -1 Then
            Add = -1
            
            Exit Function
        End If
    End If
    
    If Index = -1 Then
        LBCB.AddItem StringToAdd
    Else
        LBCB.AddItem StringToAdd, Index
    End If
    
    NW = LBCB.NewIndex
    LBCB.ItemData(NW) = ItemData
    
    Add = NW
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    Add = -2
    
    Call ERROR(LB_CB, "Add", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function AddFromPath(LBCB As Object, Path As String, Add As AddInfo, _
                            Optional ClearBeforAdding As Boolean = True) As Long
    Dim Fl() As String, Dl() As String

    On Local Error GoTo Quit
    
    AddFromPath = DLL.Directory.Read(Path, Dl, Fl, vbHidden + vbReadOnly + vbSystem)
    
    If AddFromPath <> 0 Then Exit Function
    
    Select Case Add
        Case addDIRS:  AddFromPath = AddArray(LBCB, Dl, , ClearBeforAdding)
        Case addFILES: AddFromPath = AddArray(LBCB, Fl, , ClearBeforAdding)
    End Select
    
    Exit Function
    
Quit:
    AddFromPath = Err.Number

    Call ERROR(LB_CB, "AddFromPath", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function LB_AllowResize(ListBox As Object, _
                               Optional DeactivateResizing As Boolean = False) As Long
    LB_AllowResize = DLL.CRTL.Control_AllowResize(ListBox, DeactivateResizing)
End Function
Public Sub LB_SetTabStopWidth(ListBox As Object, ByVal TabStopWidth As Long)
        
    Const LB_SETTABSTOPS = &H192

    Call SendMessage(ListBox.hwnd, LB_SETTABSTOPS, 1, TabStopWidth)
    
End Sub
Public Function LB_ScreenRows(ListBox As Object, _
                              Optional ErrorNumber As Long) As Long
    Dim nItemHeight As Long, nCount As Long
  
    On Local Error GoTo Quit
  
    ErrorNumber = 0
    
    With ListBox
        nItemHeight = SendMessageC(.hwnd, LB_GETITEMHEIGHT, 0, 0)
  
        nCount = .Parent.ScaleY(.Height, .Container.ScaleMode, vbPixels) / nItemHeight
    End With

    LB_ScreenRows = nCount

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    LB_ScreenRows = -2
    
    Call ERROR(LB_CB, "LB_ScreenRows", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Sub LB_DblClick(ListBox As Variant, Optional Index As Long = -2)
    Dim IRect As RECT
    Dim hwnd As Long
        
    If Index > -2 Then
        Call DLL.LB.Set_ListIndex(ListBox, Index)
        DoEvents
    End If
    
    hwnd = GetHwnd(ListBox)

    Call SendMessageB(hwnd, LB_GETITEMRECT, 1&, VarPtr(IRect))
    Call SendMessageB(hwnd, 515&, 0&, ByVal (CLng(IRect.Top) * 65536) + CLng(IRect.Left))

End Sub
Public Function Swap(LBCB1 As Object, LBCB2 As Object) As Long
    Dim frm As New MyControls
    
    On Local Error GoTo Quit
    
    Load frm
    
    With frm
        .Tag = "Swap"
        .LBtmp.Clear
        
        Call Copy(LBCB1, .LBtmp)
        Call Copy(LBCB2, LBCB1)
        Call Copy(.LBtmp, LBCB2)
    End With
    
    LBCB1.Refresh
    LBCB2.Refresh
        
    DoEvents
       
Quit:
    Swap = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(LB_CB, "Swap", Err.Number, Err.Description)

    Unload frm
    Set frm = Nothing

    Err.Clear
    
End Function
Public Function Copy(LBCBsource As Object, LBCBtarget As Object, _
                     Optional ClearBeforCopy As Boolean = True) As Long
    Dim P As Long
    
    On Local Error GoTo Quit

    If ClearBeforCopy Then LBCBtarget.Clear
    
    For P = 0 To LBCBsource.ListCount - 1
        LBCBtarget.AddItem LBCBsource.List(P)
        LBCBtarget.ItemData(LBCBtarget.NewIndex) = LBCBsource.ItemData(P)
    Next P
    
    If Not LBCBsource.Sorted And LBCBtarget.Sorted Then
        Call DLL.LB.Sort(LBCBtarget, soASCENDING)
    End If

    Exit Function

Quit:
    Copy = Err.Number
    
    Call ERROR(LB_CB, "Copy", Err.Number, Err.Description)

    Err.Clear

End Function
Public Function Move(LBCBsource As Object, LBCBtarget As Object) As Long
    
    On Local Error GoTo Quit
    
    Move = Copy(LBCBsource, LBCBtarget, True)
    LBCBsource.Clear
    
    Exit Function
    
Quit:
    Move = Err.Number
    
    Call ERROR(LB_CB, "Move", Err.Number, Err.Description)

    Err.Clear

End Function
Public Function ReadDatabase(LBCB As Object, _
                             Recordset As Object, Field As Variant, _
                             Optional AllowDouble As Boolean = True, _
                             Optional AllowEmpty As Boolean = True) As Long
    Dim X As Long
    Dim A As Boolean, B As Boolean
    Dim R$
    
    On Local Error Resume Next
    
    Recordset.MoveFirst
    LBCB.Clear
    
    Err.Clear
    
    On Local Error GoTo Quit
    
    If TypeOf LBCB Is ListBox Then
        A = True
    Else
        If TypeOf LBCB Is ComboBox Then
            B = True
        Else
            ReadDatabase = -1
            Exit Function
        End If
    End If
    
    Do While Not Recordset.EOF
        R$ = ""
        R$ = Recordset.Fields(Field)

        If Len(R$) = 0 Then
            If Not AllowEmpty Then GoTo LoopMe
        End If
        
        If Not AllowDouble Then
            If A Then X = LB_Find(LBCB, R$, True)
            If B Then X = CB_Find(LBCB, R$, True)
                
            If X = -1 Then LBCB.AddItem R$
        Else
            LBCB.AddItem R$
        End If

LoopMe:
        Recordset.MoveNext
    Loop

    Exit Function
    
Quit:
    ReadDatabase = Err.Number
    
    Call ERROR(LB_CB, "ReadDatabase", Err.Number, Err.Description)

    Err.Clear

End Function
Public Function apiRemoveItem(ByVal hwnd As Long, ByVal Index As Long) As Boolean
    Dim Param As Long
    Dim BT As BOXTYPE
    
    Const CB_DELETESTRING As Long = &H144
    Const LB_DELETESTRING As Long = &H182

    BT = Get_BoxTypeByHwnd(hwnd)
    
    Select Case BT
        Case isCOMBOBOX
            Param = CB_DELETESTRING
        Case isLISTBOX
            Param = LB_DELETESTRING
        Case isUNKNOWNBOXTYP
            apiRemoveItem = False
            Exit Function
    End Select
            
    apiRemoveItem = (SendMessage(hwnd, Param, Index, 0) > -1)

End Function
Public Function Get_BoxTypeByHwnd(hwnd As Long) As BOXTYPE
    Dim Class As String
    
    Get_BoxTypeByHwnd = isUNKNOWNBOXTYP

    Class = DLL.WINDOW.Get_Class(hwnd)
    
    Select Case LCase$(Class)
        Case "thunderlistbox", "thunderrt6listbox"
            Get_BoxTypeByHwnd = isLISTBOX
            Exit Function
        Case "thundercombobox", "thunderrt6combobox", _
             "thunderdrivelistbox", "thunderrt6drivelistbox"
            Get_BoxTypeByHwnd = isCOMBOBOX
            Exit Function
    End Select

End Function
Public Function apiClear(ByVal hwnd As Long) As Boolean
    Dim wMsg As Long
    
    Const CB_RESETCONTENT = &H14B
    
    Select Case Get_BoxTypeByHwnd(hwnd)
        Case isCOMBOBOX:      wMsg = CB_RESETCONTENT
        Case isLISTBOX:       wMsg = LB_RESETCONTENT
        Case isUNKNOWNBOXTYP: apiClear = False
                              Exit Function
    End Select
    
    apiClear = (SendMessage(hwnd, wMsg, ByVal CLng(0), ByVal CLng(0)) = 1)
    
End Function
Public Function CB_DeniedF4(ComboBox As Variant, _
                            Optional DeniedF4 As Boolean = True) As Long
    Dim hwnd As Long
    
    Const CB_SETEXTENDEDUI = &H155

    On Local Error GoTo Quit

    hwnd = GetHwnd(ComboBox)

    If DeniedF4 = True Then
        Call SendMessage(hwnd, CB_SETEXTENDEDUI, 1, 0)
    Else
        Call SendMessage(hwnd, CB_SETEXTENDEDUI, 0, 0)
    End If
    
    Exit Function
    
Quit:
    CB_DeniedF4 = Err.Number
    
    Call ERROR(LB_CB, "CB_DeniedF4", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function CB_GetEditHwnd(ComboBox As Variant) As Long
    Dim hwnd As Long
    
    hwnd = GetHwnd(ComboBox)
    
    CB_GetEditHwnd = FindWindowEx(hwnd, 0, "EDIT", vbNullString)
    
End Function
Public Function CB_SetCheckBoxToEditBox(ComboBox As Object, _
                                        CheckBox As Object, _
                                        Optional ErrorNumber As Long) As Boolean
    Dim hwnd As Long, TPX As Long, MrgnLeft As Long
    
    Const EC_LEFTMARGIN = &H1
    Const EM_SETMARGINS = &HD3

    On Local Error GoTo Quit
    
    If Not TypeOf ComboBox Is ComboBox Then Exit Function
    If Not TypeOf CheckBox Is CheckBox Then Exit Function
    
    hwnd = CB_GetEditHwnd(ComboBox)
    If hwnd = 0 Then Exit Function
    
    TPX = Screen.TwipsPerPixelX
    
    MrgnLeft = CheckBox.Width / TPX + 4
        
    With ComboBox
        Call SendMessage(hwnd, EM_SETMARGINS, EC_LEFTMARGIN, MrgnLeft)
      
        CheckBox.BackColor = .BackColor
        CheckBox.Move .Left + 4 * TPX, .Top + 2 * TPX, CheckBox.Width, .Height - 4 * TPX
        
        CheckBox.ZOrder 0
    End With

    CB_SetCheckBoxToEditBox = True
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(LB_CB, "CB_SetCheckBoxToEditBox", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function LB_GetRightClickedItem(ListBox As Object, _
                                       ByVal PosX As Single, ByVal PosY As Single, _
                                       Optional ItemText As String, _
                                       Optional ErrorNumber As Long) As Long
    Dim lngItem As Long, hwnd As Long, Msg As Long, wParam As Long
    Dim lParam As Long, lngResult As Long
    Dim IRect As ListRect
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    hwnd = ListBox.hwnd
    
    PosX = PosX \ Screen.TwipsPerPixelX
    PosY = PosY \ Screen.TwipsPerPixelY
    
    Msg = LB_ITEMFROMPOINT
    wParam = &H0&
    lParam = (CLng(PosY) * 65536) + CLng(PosX)
    lngItem = SendMessage(hwnd, Msg, wParam, ByVal lParam)
    
    Msg = LB_GETITEMRECT
    wParam = lngItem
    lngResult = SendMessageC(hwnd, Msg, wParam, VarPtr(IRect))
    
    If Not (((PosY >= IRect.YTop) And (PosY <= IRect.YBottom)) And _
           ((PosX >= IRect.XLeft) And (PosX <= IRect.XRight))) Then
                LB_GetRightClickedItem = -1
                Exit Function
    End If
    
    LB_GetRightClickedItem = lngItem
    ItemText = ListBox.List(lngItem)

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    LB_GetRightClickedItem = -2
    
    Call ERROR(LB_CB, "LB_GetRightClickedItem", Err.Number, Err.Description)

    Err.Clear

End Function
Public Function CB_LimitEditText(ComboBox As Variant, ByVal Textlenght As Long) As Boolean
    Dim hwnd As Long
    
    Const CB_LIMITTEXT As Long = &H141&

    hwnd = GetHwnd(ComboBox)
    
    If SendMessage(hwnd, CB_LIMITTEXT, Textlenght, 0&) = 1 Then CB_LimitEditText = True

End Function
Public Function Kill_Empty(LBCB As Object) As Long
    
    Kill_Empty = RemoveItem(LBCB, "", True)

End Function
Public Function Invert(LBCB As Object) As Long
    Dim A() As String
    Dim P As Long
    
    On Local Error GoTo Quit
    
    If LBCB.Sorted = True Then
        Invert = -1
        Exit Function
    End If
    
    If LBCB.ListCount = 0 Then
        Invert = -3
        Exit Function
    End If
    
    Invert = DLL.LB.ToArray(LBCB, A, False)
    If Invert <> 0 Then Exit Function
    
    LBCB.Clear
    
    For P = UBound(A) To 0 Step -1
        LBCB.AddItem A(P)
    Next P

    Exit Function
    
Quit:
    Invert = Err.Number
    
    Call ERROR(LB_CB, "Invert", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function Shuffle(LBCB As Object) As Long
    Dim A() As String
        
    On Local Error GoTo Quit
    
    If LBCB.Sorted = True Then
        Shuffle = -1
        Exit Function
    End If
    
    If LBCB.ListCount = 0 Then
        Shuffle = -3
        Exit Function
    End If
    
    Shuffle = ToArray(LBCB, A, False)
    If Shuffle <> 0 Then Exit Function
    
    Shuffle = DLL.ARRAY.Shuffle(A)
    If Shuffle <> 0 Then Exit Function
    
    Shuffle = AddArray(LBCB, A, True, True)
    
    Exit Function
    
Quit:
    Shuffle = Err.Number
    Shuffle = -2
    
    Call ERROR(LB_CB, "Shuffle", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function LB_GetListItemHeight(LB As Variant, _
                                     Optional ErrorNumber As Long) As Long
    Dim hwnd As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    hwnd = GetHwnd(LB)
        
    LB_GetListItemHeight = SendMessageC(hwnd, LB_GETITEMHEIGHT, 0, 0)
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(LB_CB, "LB_GetListItemHeight", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function LB_SelectAll(LB As Object, lbSelect As lbSELECTALLINFO) As Boolean
    Dim S As Boolean
    Dim P As Integer
    
    If Not TypeOf LB Is ListBox Then Exit Function
    
    Select Case lbSelect
        Case lbDeSelectAll, lbSelectAll
            S = (lbSelect = lbSelectAll)
    
            For P = 0 To LB.ListCount - 1
                LB.Selected(P) = S
            Next P
        Case lbSelectChange
            For P = 0 To LB.ListCount - 1
                LB.Selected(P) = Not (LB.Selected(P))
            Next P
        Case Else
            Exit Function
    End Select
    
    LB_SelectAll = True
    
End Function
Public Function LB_CopySelectedToLBCB(LB As Object, LBCB As Object, _
                                      Optional RemoveSelected As Boolean = True, _
                                      Optional ErrorNumber As Long) _
                                            As Boolean
    Dim P As Integer
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If Not TypeOf LB Is ListBox Then Exit Function
    
    LBCB.Clear
    
    For P = 0 To (LB.ListCount - 1)
        If LB.Selected(P) Then LBCB.AddItem LB.List(P)
    Next P
    
    If RemoveSelected Then Call LB_RemoveSelectedItems(LB)
    
    LB_CopySelectedToLBCB = True
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(LB_CB, "LB_CopySelectedToLBCB", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function LB_CopySelectedToArray(LB As Object, _
                                       Optional RemoveSelected As Boolean = True) _
                                            As String()
    Dim P As Integer
    Dim X As Long
    Dim A() As String
    
    If Not TypeOf LB Is ListBox Then Exit Function
    
    X = 0
    
    For P = 0 To (LB.ListCount - 1)
        If LB.Selected(P) Then
            ReDim Preserve A(X)
            A(X) = LB.List(P)
            
            X = X + 1
        End If
    Next P

    If RemoveSelected Then Call LB_RemoveSelectedItems(LB)

    LB_CopySelectedToArray = A
    
End Function
Public Function Compare(LBCB1 As Object, LBCB2 As Object, _
                        Optional CompareExact As Boolean = True, _
                        Optional ErrorNumber As Long) As Boolean
    Dim P As Long
    Dim R1 As String, R2 As String
    
    On Local Error GoTo Quit
    
    If LBCB1.ListCount <> LBCB2.ListCount Then Exit Function
    
    For P = 0 To (LBCB1.ListCount - 1)
        R1 = IIf(CompareExact, LBCB1.List(P), LCase$(LBCB1.List(P)))
        R2 = IIf(CompareExact, LBCB2.List(P), LCase$(LBCB2.List(P)))
    
        If R1 <> R2 Then Exit Function
    Next P
    
    Compare = True
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(LB_CB, "Compare", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function List(What As LISTINFO, LBCB As Object) As Long
    Dim RFT() As REGISTEREDFILETYPEINFO
    Dim FI() As FONTINFO
    Dim P As Long
    Dim S() As String
    
    On Local Error GoTo Quit
    
    Select Case What
        Case liSERVICES
            S = DLL.SYSTEM.Service_GetNames()
        Case liSYSTEMFONTS
            FI = DLL.MISC.Get_SystemFonts
        Case liUSER
            S = DLL.SYSTEM.Get_UserList(True)
        Case lsREGISTEREDFILETYPES
            RFT = DLL.File.Get_RegisteredFileTypes()
    End Select
    
    Select Case What
        Case liSERVICES, liUSER
            Call DLL.ARRAY.Sort(S, True)
            List = AddArray(LBCB, S, True, True)
        Case lsREGISTEREDFILETYPES
            LBCB.Clear
            
            If DLL.ARRAY.isDIM(RFT) Then
                For P = 0 To UBound(RFT)
                    LBCB.AddItem RFT(P).Prefix
                Next P
            End If
        Case liSYSTEMFONTS
            LBCB.Clear
            
            If DLL.ARRAY.isArray(FI) Then
                ReDim S(UBound(FI))
            
                For P = 0 To UBound(FI)
                    S(P) = FI(P).RegsiteredFontName
                Next P
                
                Call DLL.ARRAY.Sort(S, True)
                
                For P = 0 To UBound(FI)
                    LBCB.AddItem S(P)
                Next P

            End If
    End Select

    Exit Function
    
Quit:
    List = Err.Number
    
    Call ERROR(LB_CB, "List", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function apiItemCount(ByVal hwnd As Long) As Long
    Dim BT As BOXTYPE
    Dim wMsg As Long
    
    Const CB_GETCOUNT = &H146
    Const LB_GETCOUNT = &H18B
    
    BT = Get_BoxTypeByHwnd(hwnd)
    
    Select Case BT
        Case isCOMBOBOX:      wMsg = CB_GETCOUNT
        Case isLISTBOX:       wMsg = LB_GETCOUNT
        Case isUNKNOWNBOXTYP: apiItemCount = -1
                              Exit Function
    End Select
    
    apiItemCount = SendMessage(hwnd, wMsg, ByVal CLng(0), ByVal CLng(0))

End Function
Public Function apiReadInArray(ByVal hwnd As Long, sArray As Variant) As Long
    Dim BOXTYP As BOXTYPE
    Dim TextLen As Long, Count As Long, P As Long, X As Long, wMsg As Long, wMsg2 As Long
    Dim ItemText As String
    
    On Local Error GoTo Quit

    BOXTYP = Get_BoxTypeByHwnd(hwnd)
    
    Select Case BOXTYP
        Case isCOMBOBOX:      wMsg = CB_GETLBTEXTLEN
                              wMsg2 = CB_GETLBTEXT
        Case isLISTBOX:       wMsg = LB_GETTEXTLEN
                              wMsg2 = LB_GETTEXT
        Case isUNKNOWNBOXTYP: apiReadInArray = -1
                              Exit Function
    End Select
    
    Count = apiItemCount(hwnd)
    X = 0

    Erase sArray
    
    If Count Then
        For P = 0 To (Count - 1)
            TextLen = SendMessage(hwnd, wMsg, ByVal CLng(P), ByVal CLng(0))
            ItemText = Space(TextLen) & vbNullChar
            TextLen = SendMessage(hwnd, wMsg2, ByVal CLng(P), ByVal ItemText)
            ItemText = Left(ItemText, TextLen)
            
            ReDim Preserve sArray(X)
            sArray(X) = ItemText
            
            X = X + 1
        Next P
    End If

    Exit Function
    
Quit:
    apiReadInArray = Err.Number
    
    Call ERROR(LB_CB, "apiReadInArray", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function apiRead(hwnd As Long, LBCB As Object, _
                        Optional ErrorNumber As Long) As Long
    Dim Item() As String
    
    On Local Error GoTo Quit
    
    apiRead = apiReadInArray(hwnd, Item)
    
    If apiRead <> 0 Then Exit Function
    
    apiRead = AddArray(LBCB, Item, True, True)
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(LB_CB, "apiRead", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function apiListIndex(ByVal hwnd As Long) As Long
    Dim BOXTYP As BOXTYPE
    Dim wMsg As Long
    
    Const CB_GETCURSEL = &H147
    Const LB_GETCURSEL = &H188
    
    BOXTYP = Get_BoxTypeByHwnd(hwnd)
    
    Select Case BOXTYP
        Case isCOMBOBOX:      wMsg = CB_GETCURSEL
        Case isLISTBOX:       wMsg = LB_GETCURSEL
        Case isUNKNOWNBOXTYP: apiListIndex = -2
                              Exit Function
    End Select

    apiListIndex = SendMessage(hwnd, wMsg, ByVal CLng(0), ByVal CLng(0))

End Function
Public Function apiList(hwnd As Long, ByVal Index As Long, _
                         Optional ErrorNumber As Long) As String
    Dim BOXTYP As BOXTYPE
    Dim TextLen As Long, wMsg As Long, wMsg2 As Long
    Dim ItemText As String
    
    On Local Error GoTo Quit
    
    BOXTYP = Get_BoxTypeByHwnd(hwnd)
    
    Select Case BOXTYP
        Case isCOMBOBOX:      wMsg = CB_GETLBTEXTLEN
                              wMsg2 = CB_GETLBTEXT
        Case isLISTBOX:       wMsg = LB_GETTEXTLEN
                              wMsg2 = LB_GETTEXT
        Case isUNKNOWNBOXTYP: Exit Function
    End Select
    
    TextLen = SendMessage(hwnd, wMsg, ByVal CLng(Index), ByVal CLng(0))
    ItemText = Space(TextLen) & vbNullChar
    TextLen = SendMessage(hwnd, wMsg2, ByVal CLng(Index), ByVal ItemText)
    ItemText = Left(ItemText, TextLen)

    apiList = ItemText

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(LB_CB, "apiList", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function apiFind(ByVal hwnd As Long, ToFind As String, _
                        Optional FindExact As Boolean = True, _
                        Optional ErrorNumber As Long) As Long
    Dim BOXTYP As BOXTYPE
    Dim TextLen As Long, Count As Long, P As Long, Index As Long
    Dim wMsg As Long, wMsg2 As Long, wMsg3 As Long
    Dim ItemText As String
    
    On Local Error GoTo Quit

    ErrorNumber = 0

    If Not FindExact Then ToFind = LCase$(ToFind)

    BOXTYP = Get_BoxTypeByHwnd(hwnd)
    
    Select Case BOXTYP
        Case isCOMBOBOX:      wMsg = CB_GETLBTEXTLEN
                              wMsg2 = CB_GETLBTEXT
                              wMsg3 = CB_FINDSTRINGEXACT
        Case isLISTBOX:       wMsg = LB_GETTEXTLEN
                              wMsg2 = LB_GETTEXT
                              wMsg3 = LB_FINDSTRINGEXACT
        Case isUNKNOWNBOXTYP: apiFind = -2
                              Exit Function
    End Select
    
    Count = apiItemCount(hwnd)

    If Count Then
        Index = SearchLB(hwnd, wMsg3, -1, ToFind)
        
        For P = Index To (Count - 1)
            TextLen = SendMessage(hwnd, wMsg, ByVal CLng(P), ByVal CLng(0))
            ItemText = Space(TextLen) & vbNullChar
            TextLen = SendMessage(hwnd, wMsg2, ByVal CLng(P), ByVal ItemText)
            ItemText = Left(ItemText, TextLen)
            ItemText = IIf(FindExact, ItemText, LCase$(ItemText))
            
            If ItemText = ToFind Then
                apiFind = P
                Exit Function
            End If
        Next P
    End If

    apiFind = -1
    
    Exit Function

Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(LB_CB, "apiFind", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function LB_IndexBlink(ListBox As Object, Index As Long, _
                              Optional BlinkTimes As Long = 3, _
                              Optional PauseInMS As Long = 200) As Long
    Dim P As Long
    
    On Local Error GoTo Quit
    
    BlinkTimes = (BlinkTimes * 2) + 1
    
    For P = 1 To BlinkTimes
        If (P / 2) <> Int(P / 2) Then
            ListBox.ListIndex = -1
        Else
            ListBox.ListIndex = Index
        End If
        
        Call DLL.MISC.Sleep(PauseInMS)
        
        DoEvents
    Next P
    
    ListBox.ListIndex = Index

    Exit Function
    
Quit:
    LB_IndexBlink = Err.Number
    
    Call ERROR(LB_CB, "LB_IndexBlink", Err.Number, Err.Description)
    
    Err.Clear

End Function
