VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RTF"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function SendMessageString Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long

Public Type RTFCONTROLDIMENSIONS
    Height As Long
    Width  As Long
End Type

Public Type CURSORINFO
    CULOMN As Long
    Row    As Long
End Type

Private Type CHARFORMAT2
    cbSize                  As Integer
    wPad1                   As Integer
    dwMask                  As Long
    dwEffects               As Long
    yHeight                 As Long
    yOffset                 As Long
    crTextColor             As Long
    bCharSet                As Byte
    bPitchAndFamily         As Byte
    szFaceName(0 To 32 - 1) As Byte
    wPad2                   As Integer
    wWeight                 As Integer
    sSpacing                As Integer
    crBackColor             As Long
    lLCID                   As Long
    dwReserved              As Long
    sStyle                  As Integer
    wKerning                As Integer
    bUnderlineType          As Byte
    bAnimation              As Byte
    bRevAuthor              As Byte
    bReserved1              As Byte
End Type

Public Enum TextBoxOperation
    tbCUT = 1
    tbCOPY = 2
    tbPASTE = 3
    tbREPLACE = 4
    tbUNDO = 5
End Enum

Public Function AddColoredText(ByRef RTF As Object, ByVal TEXT As String, _
                               ByVal Color As Long, _
                               Optional ErrorNumber As Long) As Boolean
    Dim lngLength As Long, lngSelStart As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    lngLength = Len(TEXT)
    
    With RTF
        lngSelStart = .SelStart

        .SelLength = 0
        .SelText = TEXT
        .SelStart = lngSelStart
        .SelLength = lngLength
        .SelColor = Color
        .SelLength = 0
        .SelStart = lngSelStart + lngLength
    End With
    
    AddColoredText = True
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(RTF_, "AddColoredText", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function InsertPicture(ByRef RTF As Object, ByRef pic As IPictureDisp, _
                              Optional POS As Long = 0) As Long
    Dim T$
    
    On Local Error GoTo Quit
    
    T$ = Clipboard.GetText
    
    Clipboard.Clear
    Clipboard.SetData pic

    If POS > 0 And POS <= Len(RTF.TEXT) Then
        RTF.SelStart = POS
        RTF.SelLength = 0
    End If
    
    Call SendMessage(RTF.hwnd, WM_PASTE, 0, 0)
    
    Clipboard.Clear
    Clipboard.SetText T$
    
    Exit Function
    
Quit:
    InsertPicture = Err.Number

    Call ERROR(RTF_, "InsertPicture", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Get_LineCount(ByRef RTF As Object, _
                              Optional ErrorNumber As Long) As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Get_LineCount = SendMessageB(RTF.hwnd, EM_GETLINECOUNT, 0, 0&)

    Exit Function

Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(RTF_, "Get_LineCount", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Get_CursorPos(ByRef RTF As Object, Optional ErrorNumber As Long) As CURSORINFO

    Const EM_LINEFROMCHAR = &HC9
    Const EM_LINEINDEX = &HBB

    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Get_CursorPos.Row = SendMessage(RTF.hwnd, EM_LINEFROMCHAR, RTF.SelStart, 0&) + 1
    Get_CursorPos.CULOMN = RTF.SelStart - SendMessage(RTF.hwnd, EM_LINEINDEX, Get_CursorPos.Row - 1, 0&) + 1
    
    Exit Function

Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(RTF_, "Get_CursorPos", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Get_Line(ByRef RTF As Object, ByVal Line As Long, _
                         Optional ErrorNumber As Long) As String
    Dim Lo As Long, Hi As Long, Result As Long
    Dim Buffer As String

    Const MAX_CHAR_PER_LINE = &H100
    Const EM_GETLINE = &HC4

    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Line = Line - 1

    Lo = MAX_CHAR_PER_LINE And &HFF
    Hi = Int(MAX_CHAR_PER_LINE / &H100)
    
    Buffer = Chr$(Lo) & Chr$(Hi) & Space$(MAX_CHAR_PER_LINE - 2)
    
    Result = SendMessageB(RTF.hwnd, EM_GETLINE, Line, Buffer)
    
    Get_Line = Left$(Buffer, Result)

    Exit Function

Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(RTF_, "Get_Line", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Get_TextDimensions(ByRef RTF As Object, _
                                   Optional ErrorNumber As Long) As RTFCONTROLDIMENSIONS
    Dim hDcT As Long
    Dim R As RECT
  
    On Local Error GoTo Quit
  
    ErrorNumber = 0
  
    hDcT = RTF.Parent.hDC
    
    Call DrawText(hDcT, CStr(RTF.TEXT), -1, R, DT_CALCRECT)
    
    Get_TextDimensions.Height = R.Bottom
    Get_TextDimensions.Width = R.Right
        
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(RTF_, "Get_TextDimensions", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function RTF_Operation(RTF As Object, OPERATION As TextBoxOperation, _
                              Optional TextToReplace As String) As Long
    Dim hwnd As Long, wMsg As Long
    
    Const WM_CUT = &H300
    Const WM_COPY = &H301
    Const EM_REPLACESEL = &HC2
    Const EM_UNDO = &HC7

    On Local Error GoTo Quit
    
    hwnd = RTF.hwnd
    
    Select Case OPERATION
        Case tbREPLACE
            Call SendMessageString(hwnd, EM_REPLACESEL, 1, TextToReplace)
            Exit Function
        Case tbCUT:   wMsg = WM_CUT
        Case tbCOPY:  wMsg = WM_COPY
        Case tbPASTE: wMsg = WM_PASTE
        Case tbUNDO:  wMsg = EM_UNDO
        Case Else:    Exit Function
    End Select
    
    Call SendMessageLong(hwnd, wMsg, 0, 0)

    Exit Function
    
Quit:
    RTF_Operation = Err.Number
    
    Call ERROR(RTF_, "RTF_Operation", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function SetSelForeColor(RTF As Object, ByVal Color As Long) As Long
    Dim I As Long, C As Long

    On Local Error GoTo Quit
    
    With RTF
        On Error Resume Next
         
        C = .SelColor
         
        If .SelLength = 0 Then
            SetSelForeColor = -1
            Exit Function
         End If
         
        I = .SelLength
        
        .SelColor = Color
        .SelLength = 0
        .SelStart = .SelStart + I
        .SelColor = C
    End With

    Exit Function

Quit:
    SetSelForeColor = Err.Number
    
    Call ERROR(RTF_, "SetSelForeColor", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function SetSelBackColor(RTF As Object, ByVal Color As OLE_COLOR) As Long
    Dim udtChar As CHARFORMAT2
    Dim RTFhwnd As Long
   
    Const CFM_BACKCOLOR = &H4000000
    Const SCF_SELECTION = &H1&
    Const EM_SETCHARFORMAT = (&H400 + 68)

    On Local Error GoTo Quit
    
    RTFhwnd = RTF.hwnd
   
    udtChar.dwMask = CFM_BACKCOLOR
    udtChar.crBackColor = TranslateColor(Color)
    udtChar.cbSize = Len(udtChar)
      
    Call SendMessage(RTF.hwnd, EM_SETCHARFORMAT, SCF_SELECTION, udtChar)
    
    Exit Function
    
Quit:
    SetSelBackColor = Err.Number

    If Err.Number <> 0 Then Call ERROR(RTF_, "SetSelBackColor", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Private Function TranslateColor(ByVal clr As OLE_COLOR, Optional hPal As Long = 0) As Long
    If OleTranslateColor(clr, hPal, TranslateColor) Then TranslateColor = -1
End Function
Public Function ColorizeWords(RTF As Object, _
                              ByVal ColorizeWord As String, _
                              ByVal ForeColor As Long, _
                              Optional BackColor As Long = -1, _
                              Optional DoTextCompare As Boolean = True, _
                              Optional OnlyWholeWords As Boolean = True, _
                              Optional ErrorNumber As Long) As Boolean
    Dim I As Long, j As Long
    Dim SelStart As Long, WordLen As Long, TextLen As Long
    Dim DoIt As Boolean
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    SelStart = RTF.SelStart
    WordLen = Len(ColorizeWord)
    TextLen = Len(RTF.TEXT)
    
    I = 1
      
    Do
        If DoTextCompare Then
            j = InStr(I, RTF.TEXT, ColorizeWord, vbTextCompare)
        Else
            j = InStr(I, RTF.TEXT, ColorizeWord, vbBinaryCompare)
        End If
        
        If j = 0 Then Exit Do
        
        DoIt = True
         
        If OnlyWholeWords Then
            If j > 1 Then
                If mID$(RTF.TEXT, j - 1, 1) > Chr(32) Then DoIt = False
            End If
            
            If (j + WordLen) < TextLen Then
                If mID$(RTF.TEXT, j + WordLen, 1) > Chr(32) Then DoIt = False
            End If
        End If
         
        RTF.SelStart = j - 1
        RTF.SelLength = WordLen
        
        If DoIt Then
            Call SetSelBackColor(RTF, BackColor)
            Call SetSelForeColor(RTF, ForeColor)
        End If
        
        I = j + WordLen
    Loop
      
    RTF.SelLength = 0
    RTF.SelStart = SelStart
            
    ColorizeWords = True
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(RTF_, "ColorizeWords", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function sPrint(RTF As Object, Optional RightSpaceMM As Long = 25, _
                       Optional LeftSpaceMM As Long = 25) As Long
    
    On Local Error GoTo Quit
    
    Printer.Print
    
    With RTF
        .SelStart = 0
        .SelLength = Len(.TEXT)
        
        .SelIndent = Printer.ScaleX(LeftSpaceMM, vbMillimeters, Printer.ScaleMode)
        .SelRightIndent = Printer.ScaleX(RightSpaceMM, vbMillimeters, Printer.ScaleMode)
    
        .SelPrint Printer.hDC, False
    
        .SelIndent = 0
        .SelRightIndent = 0
    End With
    
Quit:
    If Err.Number <> 0 Then
        sPrint = Err.Number

        Call ERROR(RTF_, "sPrint", Err.Number, Err.Description)
    End If
    
    Printer.EndDoc

    Err.Clear
    
End Function
Public Function Set_TabStopWidth(RTF As Object, NewTabStopWidth As Long) As Long
    
    Const EM_SETTABSTOPS As Long = &HCB&
    
    On Local Error GoTo Quit
    
    Call SendMessage(RTF.hwnd, EM_SETTABSTOPS, 2, NewTabStopWidth)
    
    Exit Function
    
Quit:
    Set_TabStopWidth = Err.Number
    
    Call ERROR(RTF_, Set_TabStopWidth, Err.Number, Err.Description)
    
    Err.Clear
    
End Function
