VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTooltip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub InitCommonControls Lib "comctl32.dll" ()

Private Enum TT_Flags
    TTF_IDISHWND = &H1
    TTF_CENTERTIP = &H2
    TTF_RTLREADING = &H4
    TTF_SUBCLASS = &H10
    TTF_TRACK = &H20
    TTF_ABSOLUTE = &H80
    TTF_TRANSPARENT = &H100
    TTF_DI_SETITEM = &H8000&
End Enum

Private Type TOOLINFO
    cbSize As Long
    uFlags As TT_Flags
    hwnd As Long
    uId As Long
    RECT As RECT
    hInst As Long
    lpszText As String
    
    #If (WIN32_IE >= &H300) Then
        lParam As Long
    #End If
End Type

Public Enum ttDelayTimeConstants
    ttDelayDefault = 0
    ttDelayInitial = 3
    ttDelayShow = 2
    ttDelayReshow = 1
    ttDelayMask = 3
End Enum

Public Enum ttMarginConstants
    ttMarginLeft = 0
    ttMarginTop = 1
    ttMarginRight = 2
    ttMarginBottom = 3
End Enum

Public Enum TT_Msgs
    TTM_ENUMTOOLS = (WM_USER + 14)
    TTM_SETDELAYTIME = (WM_USER + 3)
    TTM_GETTIPTEXTCOLOR = (WM_USER + 23)
    TTM_SETMAXTIPWIDTH = (WM_USER + 24)
    TTM_UPDATE = (WM_USER + 29)
    TTM_ADDTOOL = (WM_USER + 4)
    TTM_GETTOOLCOUNT = (WM_USER + 13)
    TTM_UPDATETIPTEXT = (WM_USER + 12)
End Enum

Private Const TOOLTIPS_CLASS = "tooltips_class32"

Private Const TTM_DELTOOL = (WM_USER + 5)
Private Const TTM_GETTIPBKCOLOR = (WM_USER + 22)
Private Const TTM_SETTIPBKCOLOR = (WM_USER + 19)
Private Const TTM_GETDELAYTIME = (WM_USER + 21)
Private Const TTM_SETTIPTEXTCOLOR = (WM_USER + 20)
Private Const TTM_GETMARGIN = (WM_USER + 27)
Private Const TTM_SETMARGIN = (WM_USER + 26)
Private Const TTM_GETMAXTIPWIDTH = (WM_USER + 25)

Private m_hwndTT As Long
Private m_cMaxTip As Long

Public Function Create(frm As Form) As Boolean
  
    If (m_hwndTT = 0) Then
        Call InitCommonControls
    
        m_hwndTT = CreateWindowEx(0, TOOLTIPS_CLASS, vbNullString, TTS_ALWAYSTIP, 0, 0, 0, 0, frm.hwnd, 0, App.hInstance, ByVal 0)
    End If
  
    Create = CBool(m_hwndTT)

End Function
Private Sub Class_Terminate()
    If m_hwndTT = 0 Then Call DestroyWindow(m_hwndTT)
End Sub
Public Function AddTool(ctrl As Control, Optional sText As String) As Boolean
    Dim ti As TOOLINFO
  
    On Local Error GoTo Quit
    
    If (m_hwndTT = 0) Then Exit Function
  
    If (GetToolInfo(ctrl.hwnd, ti) = False) Then
        With ti
            .cbSize = Len(ti)
            .uFlags = TTF_SUBCLASS Or TTF_IDISHWND
            .hwnd = ctrl.Container.hwnd
            .uId = ctrl.hwnd
      
            If Len(sText) Then
                .lpszText = sText
            Else
                .lpszText = "Tool" & ToolCount + 1
            End If
        
            m_cMaxTip = Max(m_cMaxTip, Len(.lpszText) + 1)
        End With
    
        AddTool = SendMessage(m_hwndTT, TTM_ADDTOOL, 0, ti)
  End If
  
Quit:
  If Err.Number <> 0 Then Call ERROR(TT, "AddTool", Err.Number, Err.Description)
  
  Err.Clear
  
End Function
Public Function RemoveTool(ctrl As Control) As Boolean
    Dim ti As TOOLINFO

    If (m_hwndTT = 0) Then Exit Function
  
    If GetToolInfo(ctrl.hwnd, ti) Then
        Call SendMessage(m_hwndTT, TTM_DELTOOL, 0, ti)
        RemoveTool = True
    End If

End Function
Public Property Get BackColor() As OLE_COLOR
    If (m_hwndTT = 0) Then Exit Property
    BackColor = SendMessage(m_hwndTT, TTM_GETTIPBKCOLOR, 0, 0)
End Property
Public Property Let BackColor(clr As OLE_COLOR)
    If (m_hwndTT = 0) Then Exit Property
    Call SendMessage(m_hwndTT, TTM_SETTIPBKCOLOR, clr, 0)
End Property
Public Property Get DelayTime(dwType As ttDelayTimeConstants) As Long
    If (m_hwndTT = 0) Then Exit Property
    DelayTime = SendMessage(m_hwndTT, TTM_GETDELAYTIME, (dwType And ttDelayMask), 0&)
End Property
Public Property Let DelayTime(dwType As ttDelayTimeConstants, dwMilliSecs As Long)
    If (m_hwndTT = 0) Then Exit Property
    Call SendMessage(m_hwndTT, TTM_SETDELAYTIME, (dwType And ttDelayMask), ByVal dwMilliSecs)
End Property
Public Property Get ForeColor() As OLE_COLOR
    If (m_hwndTT = 0) Then Exit Property
    ForeColor = SendMessage(m_hwndTT, TTM_SETTIPTEXTCOLOR, 0, 0)
End Property
Public Property Let ForeColor(clr As OLE_COLOR)
    If (m_hwndTT = 0) Then Exit Property
    Call SendMessage(m_hwndTT, TTM_SETTIPTEXTCOLOR, clr, 0)
End Property
Public Property Get hwnd() As Long
    hwnd = m_hwndTT
End Property
Public Property Get Margin(dwType As ttMarginConstants) As Long
    Dim rc As RECT
  
    If (m_hwndTT = 0) Then Exit Property
  
    Call SendMessage(m_hwndTT, TTM_GETMARGIN, 0, rc)
  
    Select Case dwType
        Case ttMarginLeft:   Margin = rc.Left
        Case ttMarginTop:    Margin = rc.Top
        Case ttMarginRight:  Margin = rc.Right
        Case ttMarginBottom: Margin = rc.Bottom
    End Select

End Property
Public Property Let Margin(dwType As ttMarginConstants, cPixels As Long)
    Dim rc As RECT
  
    If (m_hwndTT = 0) Then Exit Property
  
    Call SendMessage(m_hwndTT, TTM_GETMARGIN, 0, rc) ' no rtn val
  
    Select Case dwType
        Case ttMarginLeft:   rc.Left = cPixels
        Case ttMarginTop:    rc.Top = cPixels
        Case ttMarginRight:  rc.Right = cPixels
        Case ttMarginBottom: rc.Bottom = cPixels
    End Select
  
    Call SendMessage(m_hwndTT, TTM_SETMARGIN, 0, rc)
    
End Property
Public Property Get MaxTipWidth() As Integer
    
    If (m_hwndTT = 0) Then Exit Property
    MaxTipWidth = LOWORD(SendMessage(m_hwndTT, TTM_GETMAXTIPWIDTH, 0, 0))

End Property
Public Function LOWORD(dwValue As Long) As Integer
    Call MoveMemory(LOWORD, dwValue, 2)
End Function
Public Property Let MaxTipWidth(ByVal cX As Integer)
    If (m_hwndTT = 0) Then Exit Property
    If (cX < 1) Then cX = -1
  
    Call SendMessage(m_hwndTT, TTM_SETMAXTIPWIDTH, 0, ByVal CLng(cX))

End Property
Public Property Get ToolCount() As Integer
    If (m_hwndTT = 0) Then Exit Property
    ToolCount = SendMessage(m_hwndTT, TTM_GETTOOLCOUNT, 0, 0)
End Property
Public Property Get ToolText(ctrl As Control) As String
    Dim ti As TOOLINFO
     
    If (m_hwndTT = 0) Then Exit Property
  
    If GetToolInfo(ctrl.hwnd, ti, True) Then
        ToolText = GetStrFromBufferA(ti.lpszText)
    End If

End Property
Private Function GetStrFromBufferA(szA As String) As String
  
    If InStr(szA, vbNullChar) Then
        GetStrFromBufferA = Left$(szA, InStr(szA, vbNullChar) - 1)
    Else
        GetStrFromBufferA = szA
    End If

End Function
Public Property Let ToolText(ctrl As Control, sText As String)
    Dim ti As TOOLINFO
  
    If (m_hwndTT = 0) Then Exit Property
  
    If GetToolInfo(ctrl.hwnd, ti) Then
        ti.lpszText = sText
        m_cMaxTip = Max(m_cMaxTip, Len(sText) + 1)
        Call SendMessage(m_hwndTT, TTM_UPDATETIPTEXT, 0, ti)
    End If

End Property
Private Function GetToolInfo(hwndTool As Long, ti As TOOLINFO, Optional fGetText As Boolean = False) As Boolean
    Dim nItems As Integer, i As Integer
  
    ti.cbSize = Len(ti)
    If fGetText Then ti.lpszText = STRING$(m_cMaxTip, 0)
    
    nItems = ToolCount
  
    For i = 0 To nItems - 1
        If SendMessage(m_hwndTT, TTM_ENUMTOOLS, (i), ti) Then
            If (hwndTool = ti.uId) Then
                GetToolInfo = True
                Exit Function
            End If
        End If
    Next i

End Function
Private Function Max(param1 As Long, param2 As Long) As Long
    If param1 > param2 Then Max = param1 Else Max = param2
End Function
Public Sub SetBKColor(ByVal Color As Long)
    If m_hwndTT <> 0 Then Call SendMessage(m_hwndTT, TTM_SETTIPBKCOLOR, Color, 0)
End Sub
Public Sub SetTXTColor(ByVal Color As Long)
    If m_hwndTT <> 0 Then Call SendMessage(m_hwndTT, TTM_SETTIPTEXTCOLOR, Color, 0)
End Sub
