Attribute VB_Name = "basFolderBrowser"
Option Explicit

Private Declare Function ILCreateFromPath Lib "shell32" Alias "#157" (ByVal sPath As String) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long

Private Declare Sub SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal Hwnd As Long, ByVal CSIDL As Long, ByRef pPIDL As Long)
Private Declare Sub CoInitialize Lib "ole32.dll" (ByRef pvReserved As Any)
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)

Private strSelectCustomFolderPath As String
Private strInvalidSelectionMsg As String, strInvalidSelectionTitle As String
Public Function ShellBrowseForFolder(BROWSEINFO As BROWSENFO) As String
    Dim typBrowseInfo As BROWSEINFO
    Dim folderPIDL As Long
    Dim strBuff As String

    With BROWSEINFO
        strSelectCustomFolderPath = .SELECTEDFOLDERPATH
        strInvalidSelectionMsg = .INVALIDSELECTIONMESSAGE
        strInvalidSelectionTitle = .INVALIDSELECTIONTITLE
    
        If .ROOTPATH <> "" Then
            folderPIDL = getPIDLfromPath(.ROOTPATH)
        ElseIf .SYSROOT <> 0 Then
            SHGetSpecialFolderLocation .Hwnd, .SYSROOT, folderPIDL
        End If
    End With

    With typBrowseInfo
        .hWndOwner = BROWSEINFO.Hwnd
        .pidlRoot = folderPIDL
        .ulFlags = BROWSEINFO.Flags
        .lpszTitle = BROWSEINFO.Title
        .lpfn = FnPtrToLong(AddressOf BrowseCallbackProc)
        .pszDisplayName = Space$(MAX_PATH)
    End With
  
    Call CoInitialize(0)
    
    folderPIDL = SHBrowseForFolder(typBrowseInfo)
    
    If Left$(typBrowseInfo.pszDisplayName, 1) <> " " Then
        BROWSEINFO.RETURNEDFOLDERPATH = typBrowseInfo.pszDisplayName
        BROWSEINFO.RETURNEDFOLDERPATH = Left$(BROWSEINFO.RETURNEDFOLDERPATH, InStr(BROWSEINFO.RETURNEDFOLDERPATH, vbNullChar) - 1)
    End If
  
    If (folderPIDL) Then
        strBuff = Space$(MAX_PATH)
        Call SHGetPathFromIDList(folderPIDL, strBuff)
        strBuff = Left$(strBuff, InStr(strBuff, vbNullChar) - 1)
    
        Call CoTaskMemFree(folderPIDL)
        
        ShellBrowseForFolder = strBuff
    Else
        ShellBrowseForFolder = ""
    End If

End Function
Private Function FnPtrToLong(ByVal lngFnPtr As Long) As Long
    FnPtrToLong = lngFnPtr
End Function
Private Function getPIDLfromPath(ByVal sPath As String) As Long
    
    getPIDLfromPath = ILCreateFromPath(sPath)
    
    If getPIDLfromPath = 0 Then
        sPath = StrConv(sPath, vbUnicode)
        getPIDLfromPath = ILCreateFromPath(sPath)
    End If

End Function
Private Function ShellGetSystemFolderPath(CSIDL As SHELLSPECIALFOLDER, Optional hWndOwner As Long) As String
    Dim strBuff As String
    Dim pPIDL As Long
  
    Call SHGetSpecialFolderLocation(hWndOwner, CSIDL, pPIDL)
    strBuff = Space$(MAX_PATH)
    Call SHGetPathFromIDList(pPIDL, strBuff)
    ShellGetSystemFolderPath = Left$(strBuff, InStr(strBuff, Chr$(0)) - 1)

End Function
Private Function BrowseCallbackProc(ByVal Hwnd As Long, ByVal uMsg As Long, ByVal lParam As Long, ByVal wParam As Long) As Long
    Dim strBuff As String
     
    Const BFFM_SETSELECTIONA = (WM_USER + 102)
    Const BFFM_INITIALIZED = 1
    Const BFFM_SELCHANGED = 2
    Const BFFM_SETSTATUSTEXTA = (WM_USER + 100)
    Const BFFM_VALIDATEFAILEDA = 3

    Select Case uMsg
        Case Is = BFFM_INITIALIZED
                If strSelectCustomFolderPath <> "" Then
                    Call SendMessage(Hwnd, BFFM_SETSELECTIONA, 1, strSelectCustomFolderPath)
                Else
                    strBuff = ShellGetSystemFolderPath(0, Hwnd)
                    Call SendMessage(Hwnd, BFFM_SETSELECTIONA, 1, strBuff)
                End If
        Case Is = BFFM_SELCHANGED
                strBuff = Space$(MAX_PATH)
            
                If SHGetPathFromIDList(lParam, strBuff) Then Call SendMessage(Hwnd, BFFM_SETSTATUSTEXTA, 0&, strBuff)                     '<--//*  set the Statustext to Folders Path
        Case Is = BFFM_VALIDATEFAILEDA
                If strInvalidSelectionMsg <> "" Then MsgBox strInvalidSelectionMsg, , strInvalidSelectionTitle
    End Select
    
    BrowseCallbackProc = 0

End Function
